## rekall 1.6.0%2Bdfsg

=== tools/linux/lmap/minpmem/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

set(MODULE_NAME pmem_pte)
set(PACKAGED_NAME packaged_pmem)
set(MODULE_SOURCE_FILES
  pmem.c
  debug.h
  pte_mmap.c
  pte_mmap.h
  pte_mmap_linux.c
  pte_mmap_linux.h
)
set(MODULE_OUTPUT_DIR ${CMAKE_BINARY_DIR}/modules)
set(MODULE_FILE ${MODULE_NAME}.ko)
set(PACKAGED_FILE ${PACKAGED_NAME}.o)

# Prepare the build scripts
set(KERNEL_VERSION ${CMAKE_SYSTEM_VERSION})
set(KERNEL_HEADERS ${CMAKE_BINARY_DIR}/kernel_headers)
configure_file(
  "${PROJECT_SOURCE_DIR}/minpmem/get_kernel_headers.sh.in"
  "${PROJECT_BINARY_DIR}/kernel_headers/get_kernel_headers.sh"
)
file(MAKE_DIRECTORY "${KERNEL_HEADERS}")
# Create copy of kernel headers in build dir
# This will modify the Makefile to never build with FTRACE
execute_process(
  WORKING_DIRECTORY ${KERNEL_HEADERS}
  COMMAND bash get_kernel_headers.sh
)
# Drop Kbuild file in build directory
configure_file(Kbuild.in ${MODULE_OUTPUT_DIR}/Kbuild)
# Copy module sources to build directory
foreach(MODULE_SOURCE_FILE ${MODULE_SOURCE_FILES})
  configure_file(
    ${MODULE_SOURCE_FILE}
    ${MODULE_OUTPUT_DIR}/${MODULE_SOURCE_FILE}
    COPYONLY
  )
endforeach(MODULE_SOURCE_FILE)

# Invoke Kbuild
add_custom_command(
  OUTPUT ${MODULE_OUTPUT_DIR}/${MODULE_FILE}
  COMMAND ${CMAKE_MAKE_PROGRAM}
          -C ${KERNEL_HEADERS}
          M=${MODULE_OUTPUT_DIR}
          modules
  WORKING_DIRECTORY ${MODULE_OUTPUT_DIR}
  DEPENDS ${MODULE_SOURCE_FILES} Kbuild.in
  COMMENT "compiling minpmem kernel module"
  VERBATIM
)

# Package minpmem so it can be linked into lmap
add_custom_command(
  OUTPUT ${MODULE_OUTPUT_DIR}/${PACKAGED_FILE}
  COMMAND strip --strip-unneeded -R .comment -R .modinfo -R .note.gnu.build-info 
    -R .gnu.linkonce.this_module -R __versions -R .note.gnu.build-id 
    -R .note.GNU-stack ${MODULE_OUTPUT_DIR}/${MODULE_FILE}
  COMMAND objcopy --input-target binary --output-target elf64-x86-64
  --binary-architecture i386 ${MODULE_OUTPUT_DIR}/${MODULE_FILE} ${MODULE_OUTPUT_DIR}/${PACKAGED_FILE}
  WORKING_DIRECTORY ${MODULE_OUTPUT_DIR}
  DEPENDS ${MODULE_OUTPUT_DIR}/${MODULE_FILE}
  COMMENT "packaging minpmem in a library"
  VERBATIM
)

# Make the module a target
add_custom_target(${MODULE_NAME} ALL DEPENDS ${MODULE_OUTPUT_DIR}/${MODULE_FILE})
# Finally create a library from our stripped pmem
add_library(minpmem STATIC ${MODULE_OUTPUT_DIR}/${PACKAGED_FILE})
# Since CMake didn't build this .o file need to tell it how to link it.
set_target_properties(minpmem PROPERTIES LINKER_LANGUAGE C)

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=2

%:
	dh $@ --with python2 --buildsystem=pybuild

override_dh_auto_clean:
	rm -rf $(CURDIR)/rekall-agent/rekall_agent/message_data
	rm -rf $(CURDIR)/rekall-agent/rekall_agent/test_data
	dh_auto_clean -- --dir=$(CURDIR)/rekall-core
	dh_auto_clean -- --dir=$(CURDIR)/rekall-agent

override_dh_auto_build:
	cp -rv $(CURDIR)/rekall-agent/messages $(CURDIR)/rekall-agent/rekall_agent/message_data
	cp -rv $(CURDIR)/rekall-agent/test_data $(CURDIR)/rekall-agent/rekall_agent
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-core
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-agent

override_dh_auto_configure \
override_dh_auto_install:
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-core
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-agent

override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
	PYBUILD_TEST_ARGS="cd {build_dir}/rekall; \
	                   python{version} addrspace_test.py; \
	                   python{version} obj_test.py; \
	                   python{version} plugins/common/profile_index_test.py; \
	                   python{version} plugins/tools/profile_tool_test.py; \
	                   python{version} plugins/tools/yara_support_test.py; \
	                   python{version} testlib.py" \
	  dh_auto_test --

override_dh_strip:
	dh_strip --exclude=ffi --exclude=/usr/tools/

override_dh_install:
	dh_install --list-missing

make_man:
	help2man -N -i debian/extra_man.txt  -h '' --version-string="1.6.0" 'rekall -h | tail -n +34' > debian/rekall.1

## rekall 1.6.0+dfsg

=== tools/linux/Makefile ===
obj-m += module.o
obj-m += pmem.o

KVER ?= $(shell uname -r)
KHEADER ?= /usr/src/linux-headers-$(KVER)
KSYSTEMMAP ?= /boot/System.map-$(KVER)
KCONFIG ?= /boot/config-$(KVER)

# Fedora Core
# KHEADER ?= /lib/modules/$(KVER)/source

# This needs to be specified because when running make under sudo we have no
# access to the PWD environment var.
PWD = `pwd`

-include version.mk

all: dwarf pmem profile

pmem: pmem.c
	$(MAKE) -C $(KHEADER) M=$(PWD) modules
	cp pmem.ko "pmem-$(KVER).ko"

dwarf: module.c
	$(MAKE) -C $(KHEADER) CONFIG_DEBUG_INFO=y M=$(PWD) modules
	cp module.ko module_dwarf.ko

profile: dwarf
	zip "$(KVER).zip" module_dwarf.ko $(KSYSTEMMAP) $(KCONFIG) "pmem-$(KVER).ko"

clean:
	$(MAKE) -C $(KHEADER) M=$(PWD) clean
	rm -f module_dwarf.ko

=== src/profiles/mspdb/Makefile ===
all:
	gcc -g -Wall test.c -fms-extensions -o test.o
	rekal dwarfparser test.o --profile_class PDBProfile --output mspdb

clean:
	rm test.o mspdb

=== tools/linux/lmap/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(lmap C)

# Force static linking
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
# Configure lmap version and symbol information
# =============================================
set(MODULE_OUTPUT_DIR ${CMAKE_BINARY_DIR}/modules)
# Replace '/' with '_' for symbol resolution of embedded pmem
string(REGEX REPLACE "/" "_" ESCAPED_OUTPUT_DIR ${MODULE_OUTPUT_DIR})
# Set up versioning
set(LMAP_VERSION_MAJOR 0)
set(LMAP_VERSION_MINOR 6)
# Set the symbol names for embedded minpmem
set(MINPMEM_START _binary_${ESCAPED_OUTPUT_DIR}_pmem_pte_ko_start)
set(MINPMEM_END _binary_${ESCAPED_OUTPUT_DIR}_pmem_pte_ko_end)
set(MINPMEM_SIZE _binary_${ESCAPED_OUTPUT_DIR}_pmem_pte_ko_size)
configure_file(
  "${PROJECT_SOURCE_DIR}/lmap/lmap_config.h.in"
  "${PROJECT_BINARY_DIR}/lmap_config.h"
)
# Prepare the README for release
configure_file(
  "${PROJECT_SOURCE_DIR}/lmap/README.in"
  "${PROJECT_BINARY_DIR}/lmap/README"
)
# Now do actual build
# ===================
# Enable make to find the configured header file
include_directories("${PROJECT_BINARY_DIR}")
# Include used libraries
include_directories("${PROJECT_SOURCE_DIR}/log")
include_directories("${PROJECT_SOURCE_DIR}/elfrelink")
# Set compiler flags
add_definitions(-std=gnu99 -Wall -static)

add_subdirectory(log)
add_subdirectory(elfrelink)
add_subdirectory(minpmem)
add_subdirectory(lmap)
add_subdirectory(kohook)
add_subdirectory(test)

=== tools/linux/vmcs_layout/Makefile ===
obj-m += vmcs_layout.o

KVER ?= $(shell uname -r)
KHEADER ?= /usr/src/linux-headers-$(KVER)

# This needs to be specified because when running make under sudo we have no
# access to the PWD environment var.
PWD = `pwd`

-include version.mk

all: vmcs_layout

vmcs_layout: vmcs_layout.c
	$(MAKE) -C $(KHEADER) M=$(PWD) modules

clean:
	$(MAKE) -C $(KHEADER) M=$(PWD) clean

=== tools/linux/lmap/elfrelink/CMakeLists.txt ===
add_definitions(-std=c99 -Wall -Wextra -ggdb)

add_library(elfrelink elfrelink.c elf_object.c elf_sections.c elf_symbols.c elf_relocations.c)

target_link_libraries(elfrelink log)

=== tools/linux/lmap/kohook/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

add_executable(kohook kohook.c)
target_link_libraries(kohook log elfrelink)

=== tools/linux/lmap/lmap/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

add_executable(lmap lmap.c memory_map.c lkm_control.c elf_dump.c kcore.c)

target_link_libraries(lmap log elfrelink minpmem)

=== tools/linux/lmap/log/CMakeLists.txt ===
add_definitions(-std=c99 -Wall -Wextra -ggdb)
add_library(log log.c)

=== tools/linux/lmap/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set(TEST_FILES host
  host.strtab
  host.strtab.h
  parasite
  parasite.shstrtab
  parasite.shstrtab.h
)

foreach(TEST_FILE ${TEST_FILES})
  configure_file(
    test_data/${TEST_FILE}
    ${CMAKE_BINARY_DIR}/test/test_data/${TEST_FILE}
    COPYONLY
  )
endforeach(TEST_FILE)

add_executable(elfrelink_test elfrelink_test.c)
target_link_libraries(elfrelink_test log elfrelink)

=== debian/changelog ===
rekall (1.6.0+dfsg-2) unstable; urgency=medium

  * Initialize patches for use with patch-queue.
  * Fix strict versioned dependencies in setup.py.
    Closes: #856926

 -- Sascha Steinbiss <satta@debian.org>  Tue, 14 Mar 2017 12:27:00 +0100

rekall (1.6.0+dfsg-1) unstable; urgency=low

  [ Hilko Bengen and Sascha Steinbiss ]
  * Initial release (Closes: #838839)

 -- Sascha Steinbiss <satta@debian.org>  Sun, 18 Dec 2016 15:37:45 +0000

=== debian/control ===
Source: rekall
Section: python
Priority: extra
Maintainer: Debian Forensics <forensics-devel@lists.alioth.debian.org>
Uploaders: Hilko Bengen <bengen@debian.org>,
           Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper (>= 9), dh-python, python-all,
 python-aff4,
 python-acora,
 python-arrow,
 python-artifacts,
 python-capstone,
 python-crypto,
 python-cryptography,
 python-efilter,
 python-filelock,
 python-html5lib,
 python-httplib2,
 python-intervaltree,
 python-ipaddr,
 python-ipython (>= 5.0.0),
 python-mock,
 python-oauth2client,
 python-pathlib,
 python-portpicker,
 python-psutil,
 python-pyelftools,
 python-requests,
 python-setuptools,
 python-sparqlwrapper,
 python-tsk,
 python-wheel,
 python-yaml,
 python-yara
Standards-Version: 3.9.8
Homepage: http://www.rekall-forensic.com/
Vcs-Git: https://anonscm.debian.org/git/forensics/rekall.git
Vcs-Browser: https://anonscm.debian.org/cgit/forensics/rekall.git

Package: python-rekall-core
Architecture: all
Depends: ${python:Depends}, ${misc:Depends},
 python-artifacts,
 python-aff4,
 python-yaml,
 python-acora,
 python-arrow,
 python-efilter,
 python-html5lib,
 python-intervaltree,
 python-crypto,
 python-pyelftools,
 python-pyparsing,
 python-tz,
 python-psutil,
 python-capstone,
 python-yara,
 python-sortedcontainers,
 python-sparqlwrapper,
 python-tsk,
 python-ipaddr,
 cabextract
Description: memory analysis and incident response framework -- core Python modules
 This package contains Python 2 modules for rekall, a collection of
 tools for the extraction and analysis of digital artifacts computer
 systems.

#Package: python-rekall-agent
#Architecture: all
#Depends: ${python:Depends}, ${misc:Depends},
# python-rekall-core (= ${binary:Version}),
# python-requests,
# python-httplib2,
# python-html5lib,
# python-oauth2client,
# python-crypto,
# python-cryptography,
# python-filelock,
# python-pathlib,
# python-portpicker
#Description: memory analysis and incident response framework -- DFIR agent component
# This package contains Python 2 modules for rekall, a collection of
# tools for the extraction and analysis of digital artifacts computer
# systems.

Package: rekall-core
Architecture: all
Section: utils
Depends: ${python:Depends}, ${misc:Depends},
 python-rekall-core (= ${binary:Version}),
 python-ipython (>= 5.0.0)
Description: memory analysis and incident response framework
 The Rekall Framework is a completely open collection of tools for the
 extraction and analysis of digital artifacts computer systems.
 .
 Rekall supports investigations of the following 32bit and 64bit memory
 images:
 .
  - Microsoft Windows XP Service Pack 2 and 3
  - Microsoft Windows 7 Service Pack 0 and 1
  - Microsoft Windows 8 and 8.1
  - Microsoft Windows 10
  - Linux Kernels 2.6.24 to 4.4.
  - OSX 10.7-10.12.x.
 .
 Rekall also provides a complete memory sample acquisition capability
 for all major operating systems.

=== debian/tests/control ===
Tests: linux-image-tests
Depends: @, xz-utils
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/google/rekall/releases /.*/v(.*)\.tar\.gz

## rekall 1.7.2~rc1+git20190104+dfsg

=== debian/changelog ===
rekall (1.7.2~rc1+git20190104+dfsg-2) unstable; urgency=medium

  * Team upload
  * Wrap too long line in extended description of python3-rekall-lib
  * Add python3-pkg-resources to dependencies
  * Add python3-sparqlwrapper to dependencies

 -- Raphaël Hertzog <raphael@offensive-security.com>  Thu, 26 Dec 2019 15:19:12 +0100

rekall (1.7.2~rc1+git20190104+dfsg-1) experimental; urgency=medium

  * Team upload.

  [ Sascha Steinbiss ]
  * New upstream version 1.7.1+dfsg

  [ Sophie Brun ]
  * Add new Excluded-files (*.exe)
  * New upstream version 1.7.2~rc1+git20190104+dfsg
  * Update debian/copyright
  * Switch to Python 3 (Closes: #927135, #938348)
  * Add new binary package debian/python3-rekall-lib
  * Use debhelper-compat 12
  * Update (build-)dependencies for new upstream version
  * Bump Standards-Version to 4.4.0
  * Update version in debian/rules for manpages build
  * Remove 0003-fix-module-paths.patch
  * Add a patch change-pycryptodome.patch: use pycryptodomex in requirements
    to fix issue with pkg_resources
  * Add a patch use-python-module-ipaddress.patch to use Python3 module
    ipaddress
  * Install and use rekall-efilter: an usptream customized Python module
    efilter for rekall.

  [ Samuel Henrique ]
  * Add salsa-ci.yml

  [ Raphaël Hertzog ]
  * Bump Standards-Version to 4.4.1
  * Fixes for python3-rekall-agent binary package (currently not built)
  * Disable parts related to python3-rekall-agent
  * Upload to experimental to help go through binary-NEW while giving some
    time for others to test this update.

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 18 Oct 2019 15:34:55 +0200

rekall (1.6.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>. Closes: #934691
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org
  * Replace priority extra with optional.

 -- Raphaël Hertzog <raphael@offensive-security.com>  Wed, 11 Sep 2019 14:19:03 +0200

=== debian/control ===
Source: rekall
Section: python
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Hilko Bengen <bengen@debian.org>,
           Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper-compat (= 12), dh-python, python3-all,
 python3-acora,
 python3-arrow,
 python3-artifacts,
 python3-capstone,
 python3-crypto,
 python3-cryptography,
 python3-filelock,
 python3-future,
 python3-html5lib,
 python3-httplib2,
 python3-intervaltree,
 python3-ipython (>= 5.0.0),
 python3-mock,
 python3-oauth2client,
 python3-pkg-resources,
 python3-portpicker,
 python3-psutil,
 python3-pyelftools,
 python3-requests,
 python3-setuptools,
 python3-sparqlwrapper,
 python3-tsk,
 python3-wheel,
 python3-yaml,
 python3-yara
Standards-Version: 4.4.1
Homepage: http://www.rekall-forensic.com/
Vcs-Git: https://salsa.debian.org/pkg-security-team/rekall.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/rekall

Package: python3-rekall-core
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends},
 python3-artifacts,
 python3-pyaff4,
 python3-yaml,
 python3-acora,
 python3-arrow,
 python3-dateutil,
 python3-future,
 python3-intervaltree,
 python3-parsedatetime,
 python3-pkg-resources,
 python3-pycryptodome,
 python3-rekall-lib (= ${binary:Version}),
 python3-sparqlwrapper,
 python3-crypto,
 python3-pyelftools,
 python3-pyparsing,
 python3-tz,
 python3-psutil,
 python3-capstone,
 python3-yara,
 python3-tsk,
 cabextract
Description: memory analysis and incident response framework -- core Python modules
 This package contains Python 3 modules for rekall, a collection of
 tools for the extraction and analysis of digital artifacts computer
 systems.

Package: python3-rekall-lib
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends},
 python3-arrow,
 python3-crypto,
 python3-future,
 python3-six,
 python3-sortedcontainers,
 python3-yaml
Description: memory analysis and incident response framework -- lib Python modules
 The Rekall Framework is a completely open collection of tools for the
 extraction and analysis of digital artifacts computer systems.
 .
 This package contains Python 3 module for rekall-lib, a lib for rekall Python
 modules.

#Package: python3-rekall-agent
#Architecture: all
#Depends: ${python3:Depends}, ${misc:Depends},
# python3-rekall-core (= ${binary:Version}),
# python3-rekall-lib (= ${binary:Version}),
# python3-requests,
# python3-httplib2,
# python3-oauth2client,
# python3-filelock,
# python3-pathlib,
# python3-portpicker
#Description: memory analysis and incident response framework -- DFIR agent component
# The Rekall Framework is a completely open collection of tools for the
# extraction and analysis of digital artifacts computer systems.
# .
# This package contains Python 3 modules for rekall-agent.

Package: rekall-core
Architecture: all
Section: utils
Depends: ${python3:Depends}, ${misc:Depends},
 python3-rekall-core (= ${binary:Version})
Description: memory analysis and incident response framework
 The Rekall Framework is a completely open collection of tools for the
 extraction and analysis of digital artifacts computer systems.
 .
 Rekall supports investigations of the following 32bit and 64bit memory
 images:
 .
  - Microsoft Windows XP Service Pack 2 and 3
  - Microsoft Windows 7 Service Pack 0 and 1
  - Microsoft Windows 8 and 8.1
  - Microsoft Windows 10
  - Linux Kernels 2.6.24 to 4.4.
  - OSX 10.7-10.12.x.
 .
 Rekall also provides a complete memory sample acquisition capability
 for all major operating systems.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=2

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	#rm -rf $(CURDIR)/rekall-agent/rekall_agent/message_data
	#rm -rf $(CURDIR)/rekall-agent/rekall_agent/test_data
	dh_auto_clean -- --dir=$(CURDIR)/rekall-core
	#dh_auto_clean -- --dir=$(CURDIR)/rekall-agent

override_dh_auto_build:
	#cp -rv $(CURDIR)/rekall-agent/messages $(CURDIR)/rekall-agent/rekall_agent/message_data
	#cp -rv $(CURDIR)/rekall-agent/test_data $(CURDIR)/rekall-agent/rekall_agent
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-core
	#$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-agent
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-lib

override_dh_auto_configure \
override_dh_auto_install:
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-core
	#$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-agent
	$(patsubst override_%,%,$@) -- --dir=$(CURDIR)/rekall-lib

override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
	PYBUILD_TEST_ARGS="cd {build_dir}/rekall; \
	                   python{version} addrspace_test.py; \
	                   python{version} obj_test.py; \
	                   python{version} plugins/common/profile_index_test.py; \
	                   python{version} plugins/tools/profile_tool_test.py; \
	                   python{version} plugins/tools/yara_support_test.py; \
	                   python{version} testlib.py" \
	  dh_auto_test --

override_dh_strip:
	dh_strip --exclude=ffi --exclude=/usr/tools/

make_man:
	help2man -N -i debian/extra_man.txt  -h '' --version-string="1.7.1" 'rekall -h | tail -n +34' > debian/rekall.1
